package version2012;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class MainClass {

	/**
	 * @param args
	 * @throws Exception 
	 * @throws Exception 
	 */

	static ExecutorService executor;
	
	private static void add_run(List<Ego> egoes,
			double rescouseWeight, double wellBeingWeight, double allianceWeight, double riskWeight, double stressWeight, double per) 
	throws Exception
	{
		Sociaty sociaty = new Sociaty(egoes, rescouseWeight, wellBeingWeight,
				riskWeight, allianceWeight, stressWeight, per);
		executor.submit(sociaty);				
		try 
		{
			Thread.sleep(20);
		} 
		catch (InterruptedException e) 
		{			
		}
	}
	public static void main(String[] args) 
	throws Exception 
	{
		int numThreads = 10;
		executor = Executors.newFixedThreadPool(numThreads);
		//rescouseWeight, wellBeingWeight, allianceWeight, riskWeight, stressWeight,
		add_run(genereatEgoes_random(300), 2, 1.5, 1, 1, 1, -1);		
		add_run(genereatEgoes_random(300), 1, 2.5, 1, 1, 1, -1);		
		add_run(genereatEgoes_random(300), 1, 1.5, 2, 1, 1, -1);		
		add_run(genereatEgoes_random(300), 1, 1.5, 1, 2, 1, -1);		
		add_run(genereatEgoes_random(300), 1, 1.5, 1, 1, 2, -1);		
		add_run(genereatEgoes_random(300), 3, 1.5, 1, 1, 1, -1);		
		add_run(genereatEgoes_random(300), 1, 3.5, 1, 1, 1, -1);		
		add_run(genereatEgoes_random(300), 1, 1.5, 3, 1, 1, -1);		
		add_run(genereatEgoes_random(300), 1, 1.5, 1, 3, 1, -1);		
		add_run(genereatEgoes_random(300), 1, 1.5, 1, 1, 3, -1);		

//		double[] a = {0.01, 0.99};
//
//		int[] population = {200, 300, 400};
//		double[] per = {0.02, 0.05};
//		for(int i = 0; i < population.length; i++)
//		{
//			for(int j = 0; j < per.length; j++)
//			{
//				int[] pop = new int[2];
//				pop[1] = (int)(per[j] * population[i]);
//				pop[0] = population[i] - pop[1];
//				add_run(genereatEgoes_uneven(pop, a), 1, 1.5, 1, 1, 1, per[j]);
//			}
//		}
		System.out.print("done");
	}

	private static List<Ego> genereatEgoes_uneven(int[] population, double[] a)
	{
		List<Ego> egoes = new ArrayList<Ego>();
		int bias = 0;
		for(int j = 0; j < population.length; j++)
		{
			for(int i = 0; i < population[j]; i++)
			{
				egoes.add(new Ego(i + bias, a[j]));
			}
			bias += population[j];
		}

		return egoes;
		
	}
	
//	private static List<Ego> genereatEgoes_even(int population)
//	{
//		List<Ego> egoes = new ArrayList<Ego>();
//		for(int i = 0; i < population; i++)
//		{
//			egoes.add(new Ego(i, i / 100.00));
//		}
//		return egoes;
//	}
//	
	private static List<Ego> genereatEgoes_random(int population)
	{
		List<Ego> egoes = new ArrayList<Ego>();
		for(int i = 0; i < population; i++)
		{
			egoes.add(new Ego(i, Math.random()));
		}
		return egoes;
	}

}
