package version2012;

public class QuickSort 
{	
	public static final int overall = 0;
	public static final int wellbeing = 1;
	public static final int resource = 2;
	public static final int alliance = 3;
	public static final int risk = 4;
	public static final int stress = 5;
	
	private static double getValue(Ego ego, int sortType, Sociaty sociaty) 
	throws Exception
	{
		if(sortType == overall)
		{
			return ego.getScore(sociaty);
		}
		else if(sortType == wellbeing)
		{
			return ego.getWellbeing();
		}
		else if(sortType == resource)
		{
			return ego.getResource();
		}
		else if(sortType == alliance)
		{
			return ego.getAlliance();
		}
		else if(sortType == risk)
		{
			return ego.getRisk();
		}
		else if(sortType == stress)
		{
			return ego.getStress();
		}
		else
		{
			throw new Exception();
		}
			
			
	}
	
	private static int partition(Ego[] egos, int left, int right, int sortType, Sociaty sociaty) 
	throws Exception 
	{ 
		int i = left, j = right; 
		Ego tmp; 
	    double pivot = getValue(egos[(left + right) / 2], sortType, sociaty);      
	    while(i <= j) 
	    {
	    	while (getValue(egos[i], sortType, sociaty)  < pivot) 
	    	{
	    		i++; 
	    	}
            
            while (getValue(egos[j], sortType, sociaty) > pivot) 
            {
            	j--; 
            }            
            if(i <= j) 
            { 
            	tmp = egos[i]; 
            	egos[i] = egos[j]; 
            	egos[j] = tmp; 
                i++; 
                j--; 
            } 
	      }       
	      return i; 
	} 

	public static void quickSort(Ego[] egos, int left, int right, int sortType, Sociaty sociaty) 
	throws Exception 
	{ 
		int index = partition(egos, left, right, sortType, sociaty); 
	    if (left < index - 1)
	    {
	    	quickSort(egos, left, index - 1, sortType, sociaty); 
	    }   
	    if (index < right) 
	    {
	    	quickSort(egos, index, right, sortType, sociaty); 
	    }
	}

}
